import { IServiceProvider } from "./IServiceProvider.js";
import { ServiceCollection } from "./ServiceCollection.js";
import type { IAsyncServiceScope, IServiceDescriptor, IServiceScope, ServiceType } from "../types/index.js";
export declare class ServiceProvider implements IServiceProvider {
    private readonly collection;
    private readonly parent?;
    static getDescriptor<T>(provider: IServiceProvider, service: ServiceType<T>): IServiceDescriptor<T>;
    static getDescriptors<T>(provider: IServiceProvider, service: ServiceType<T>): IServiceDescriptor<T>[];
    private readonly instancesStore;
    constructor(collection: ServiceCollection, parent?: IServiceProvider | undefined);
    getServices<T>(service: ServiceType<T>): T[];
    getServiceAsync<T>(service: ServiceType<T>): Promise<T>;
    getService<T>(service: ServiceType<T>): T;
    getServicesAsync<T>(service: ServiceType<T>): Promise<T[]>;
    createScope(): IServiceScope;
    createAsyncScope(): IAsyncServiceScope;
    private internalGetServices;
    private internalGetService;
    private internalGetDescriptorImplementation;
    private createInstanceFromDescriptor;
    private initializeService;
    private getDescriptor;
    private resolveGeneratorSync;
    private resolveGeneratorAsync;
    [Symbol.dispose](): void;
    [Symbol.asyncDispose](): Promise<void>;
}
//# sourceMappingURL=ServiceProvider.d.ts.map